com.smartgwt.client.widgets.layout

## Class Layout

- java.lang.Object
- - com.google.gwt.user.client.ui.UIObject
  - - com.google.gwt.user.client.ui.Widget
    - - com.smartgwt.client.widgets.BaseWidget
      - - com.smartgwt.client.widgets.Canvas
        - - com.smartgwt.client.widgets.layout.Layout

- All Implemented Interfaces:
    com.google.gwt.event.logical.shared.HasAttachHandlers, com.google.gwt.event.shared.HasHandlers, com.google.gwt.user.client.EventListener, com.google.gwt.user.client.ui.HasVisibility, com.google.gwt.user.client.ui.IsWidget, LogicalStructure, HasClickHandlers, HasDoubleClickHandlers, HasDragMoveHandlers, HasDragRepositionMoveHandlers, HasDragRepositionStartHandlers, HasDragRepositionStopHandlers, HasDragResizeMoveHandlers, HasDragResizeStartHandlers, HasDragResizeStopHandlers, HasDragStartHandlers, HasDragStopHandlers, HasDropHandlers, HasDropMoveHandlers, HasDropOutHandlers, HasDropOverHandlers, HasFocusChangedHandlers, HasHoverHandlers, HasHoverHiddenHandlers, HasKeyDownHandlers, HasKeyPressHandlers, HasMouseDownHandlers, HasMouseMoveHandlers, HasMouseOutHandlers, HasMouseOverHandlers, HasMouseStillDownHandlers, HasMouseUpHandlers, HasMouseWheelHandlers, HasMovedHandlers, HasParentMovedHandlers, HasResizedHandlers, HasRightMouseDownHandlers, HasScrolledHandlers, HasShowContextMenuHandlers, HasVisibilityChangedHandlers
  Direct Known Subclasses:
    ColumnTree, FilterBuilder, HLayout, HStack, PortalLayout, Toolbar, ToolStrip, VLayout, VStack

      public class Layout
      extends Canvas

  A subclass of Canvas that automatically arranges other Canvases according to a layout policy.
  A Layout manages a set of "member" Canvases initialized via the "members" property. Layouts can have both "members", which are managed by the Layout, and normal Canvas children, which are unmanaged.
  Rather than using the Layout class directly, use the HLayout, VLayout, HStack and VStack classes, which are subclasses of Layout preconfigured for horizontal or vertical stacking, with the "fill" (VLayout) or "none" (VStack) `policies` already set.
  Layouts and Stacks may be nested to create arbitrarily complex layouts.
  To show a resizer bar after (to the right or bottom of) a layout member, set showResizeBar to true on that member component (not on the HLayout or VLayout). Resizer bars override membersMargin spacing.
  Like other Canvas subclasses, Layout and Stack components may have % width and height values. To create a dynamically-resizing layout that occupies the entire page (or entire parent component), set width and height to "100%".
  See Also:
    `LayoutPolicy`, `VLayout`, `HLayout`, `VStack`, `HStack`, `LayoutSpacer`

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.google.gwt.user.client.ui.UIObject

      `com.google.gwt.user.client.ui.UIObject.DebugIdImpl, com.google.gwt.user.client.ui.UIObject.DebugIdImplEnabled`

  - ### Field Summary

    - ### Fields inherited from class com.smartgwt.client.widgets.BaseWidget

      `config, configOnly, id, isElementSet, nativeObject, scClassName`

    - ### Fields inherited from class com.google.gwt.user.client.ui.UIObject

      `DEBUG_ID_PREFIX`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Layout()`
    `Layout(com.google.gwt.core.client.JavaScriptObject jsObj)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addMember(Canvas component)` Add a canvas to the layout, optionally at a specific position.
    `void` | `addMember(Canvas component, int position)` Add a canvas to the layout, optionally at a specific position.
    `void` | `addMember(com.google.gwt.user.client.ui.Widget widget)` Add a canvas to the layout, optionally at a specific position.
    `void` | `addMember(com.google.gwt.user.client.ui.Widget widget, int position)`
    `protected void` | `addMemberPostCreate(java.lang.Object componentJS)`
    `protected void` | `addMemberPostCreate(java.lang.Object componentJS, int position)`
    `protected void` | `addMemberPreCreate(java.lang.Object componentJS)`
    `protected void` | `addMemberPreCreate(java.lang.Object componentJS, int position)`
    `void` | `addMembers(Canvas... newMembers)` Add one or more canvases to the layout.
    `void` | `addMembers(Canvas[] newMembers, int position)` Add one or more canvases to the layout at specific positions.
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, Canvas defaults)` Changes the defaults for Canvas AutoChildren named `autoChildName`.
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, FormItem defaults)` Changes the defaults for FormItem AutoChildren named `autoChildName`.
    `protected com.google.gwt.core.client.JavaScriptObject` | `create()`
    `java.lang.Boolean` | `getAnimateMembers()` If true when members are added / removed, they should be animated as they are shown or hidden in position
    `java.lang.Integer` | `getAnimateMemberTime()` If specified this is the duration of show/hide animations when members are being shown or hidden due to being added / removed from this layout.
    `java.lang.Boolean` | `getCanDropComponents()` Layouts provide a default implementation of a drag and drop interaction.
    `LayoutResizeBarPolicy` | `getDefaultResizeBars()` Policy for whether resize bars are shown on members by default.
    `protected Canvas` | `getDropComponent(Canvas dragTarget, int dropPosition)`
    `Canvas` | `getDropLine()` Line showed to mark the drop position when components are being dragged onto this Layout.
    `int` | `getDropLineThickness()` Thickness, in pixels of the dropLine shown during drag and drop when `canDropComponents` is set to `true`.
    `int` | `getDropPosition()` Get the position a new member would be dropped.
    `java.lang.Boolean` | `getEnforcePolicy()` Whether the layout policy is continuously enforced as new members are added or removed and as members are resized.
    `LayoutPolicy` | `getHPolicy()` Sizing policy applied to members on horizontal axis
    `java.lang.Integer` | `getLayoutBottomMargin()` Space outside of all members, on the bottom side.
    `java.lang.Integer` | `getLayoutLeftMargin()` Space outside of all members, on the left-hand side.
    `java.lang.Integer` | `getLayoutMargin()` Space outside of all members.
    `java.lang.Integer` | `getLayoutRightMargin()` Space outside of all members, on the right-hand side.
    `java.lang.Integer` | `getLayoutTopMargin()` Space outside of all members, on the top side.
    `java.lang.Boolean` | `getLeaveScrollbarGap()` Whether to leave a gap for a vertical scrollbar even when one is not actually present.
    `LocatorStrategy` | `getLocateMembersBy()` Strategy to use when locating members from within this Layout's members array.
    `LocatorTypeStrategy` | `getLocateMembersType()` `LocatorTypeStrategy` to use when finding members within this layout.
    `com.smartgwt.logicalstructure.core.LogicalStructureObject` | `getLogicalStructure()`
    `java.lang.Boolean` | `getManagePercentBreadth()` If set, a Layout with breadthPolicy:"fill" will specially interpret a percentage breadth on a member as a percentage of available space excluding the `layoutMargin`.
    `Canvas` | `getMember(int index)` Given a numerical index or a member ID, return a pointer to the appropriate member.
    `Canvas` | `getMember(java.lang.String memberID)` Given a numerical index or a member ID, return a pointer to the appropriate member.
    `void` | `getMemberDefaultBreadth(Canvas member, int defaultBreadth)` Return the breadth for a member of this layout which either didn't specify a breadth or specified a percent breadth with `managePercentBreadth`:true.
    `int` | `getMemberNumber(Canvas member)` Given a member Canvas or member ID, return the index of that member within this layout's members array
    `int` | `getMemberNumber(java.lang.String memberID)` Given a member Canvas or member ID, return the index of that member within this layout's members array
    `void` | `getMemberOffset(Canvas member, int defaultOffset, java.lang.String alignment)` Override point for changing the offset on the breadth axis for members, that is, the offset relative to the left edge for a vertical layout, or the offset relative to the top edge for a horizontal layout.
    `int` | `getMemberOverlap()` Number of pixels by which each member should overlap the preceding member, used for creating an "stack of cards" appearance for the members of a Layout.
    `Canvas[]` | `getMembers()` Return the members in the Layout.
    `int` | `getMembersMargin()` Space between each member of the layout.
    `int` | `getMinMemberSize()` Minimum size, in pixels, below which flexible-sized members should never be shrunk, even if this requires the Layout to overflow.
    `static Layout` | `getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `Overflow` | `getOverflow()` Normal `Overflow` settings can be used on layouts, for example, an overflow:auto Layout will scroll if members exceed its specified size, whereas an overflow:visible Layout will grow to accommodate members.
    `java.lang.Boolean` | `getPaddingAsLayoutMargin()` If this widget has padding specified (as `this.padding` or in the CSS style applied to this layout), should it show up as space outside the members, similar to layoutMargin?
    `java.lang.String` | `getResizeBarClass()` Class to use for creating resizeBars.
    `int` | `getResizeBarSize()` Thickness of the resizeBars in pixels
    `java.lang.Boolean` | `getReverseOrder()` Reverse the order of stacking for this Layout, so that the last member is shown first.
    `java.lang.Boolean` | `getShowDragPlaceHolder()` If set to true, when a member is dragged out of layout, a visible placeholder canvas will be displayed in place of the dragged widget for the duration of the drag and drop interaction.
    `java.lang.Boolean` | `getShowDropLines()` Controls whether to show a drop-indicator during a drag and drop operation.
    `java.lang.String` | `getStackZIndex()` For use in conjunction with `memberOverlap`, controls the z-stacking order of members.
    `java.lang.Boolean` | `getVertical()` Should this layout appear with members stacked vertically or horizontally.
    `LayoutPolicy` | `getVPolicy()` Sizing policy applied to members on vertical axis
    `java.lang.Boolean` | `hasMember(Canvas canvas)` Returns true if the layout includes the specified canvas.
    `void` | `hideDropLine()` Calling this method hides the dropLine shown during a drag and drop interaction with a Layout that has `canDropComponents` set to true.
    `void` | `hideMember(Canvas member)` Hide the specified member, firing the specified callback when the hide is complete.
    `void` | `hideMember(Canvas member, Function callback)` Hide the specified member, firing the specified callback when the hide is complete.
    `void` | `membersChanged()` Fires once at initialization if the layout has any initial members, and then fires whenever members are added, removed or reordered.
    `protected void` | `onInit_Layout()`
    `protected void` | `onInit()`
    `void` | `reflow()` Layout members according to current settings.
    `void` | `reflow(java.lang.String reason)` Layout members according to current settings.
    `void` | `reflowNow()` Layout members according to current settings, immediately.
    `void` | `removeMember(Canvas member)` Removes the specified member from the layout.
    `void` | `removeMembers(Canvas... members)` Removes the specified members from the layout.
    `void` | `reorderMember(int memberNum, int newPosition)` Shift a member of the layout to a new position
    `void` | `reorderMembers(int start, int end, int newPosition)` Move a range of members to a new position
    `void` | `setAlign(Alignment alignment)` Alignment of all members in this Layout on the length axis.
    `void` | `setAlign(VerticalAlignment alignment)` Alignment of all members in this Layout on the length axis.
    `void` | `setAnimateMembers(java.lang.Boolean animateMembers)` If true when members are added / removed, they should be animated as they are shown or hidden in position
    `void` | `setAnimateMemberTime(java.lang.Integer animateMemberTime)` If specified this is the duration of show/hide animations when members are being shown or hidden due to being added / removed from this layout.
    `void` | `setCanDropComponents(java.lang.Boolean canDropComponents)` Layouts provide a default implementation of a drag and drop interaction.
    `void` | `setDefaultLayoutAlign(Alignment alignment)` Specifies the default alignment for layout members on the breadth axis.
    `void` | `setDefaultLayoutAlign(VerticalAlignment alignment)` Specifies the default alignment for layout members on the breadth axis.
    `static void` | `setDefaultProperties(Layout layoutProperties)` Class level method to set the default properties of this class.
    `void` | `setDefaultResizeBars(LayoutResizeBarPolicy defaultResizeBars)` Policy for whether resize bars are shown on members by default.
    `void` | `setDropLineProperties(Canvas dropLineProperties)`
    `void` | `setDropLineThickness(int dropLineThickness)` Thickness, in pixels of the dropLine shown during drag and drop when `canDropComponents` is set to `true`.
    `void` | `setEnforcePolicy(java.lang.Boolean enforcePolicy)` Whether the layout policy is continuously enforced as new members are added or removed and as members are resized.
    `void` | `setHPolicy(LayoutPolicy hPolicy)` Sizing policy applied to members on horizontal axis
    `void` | `setJavaScriptObject(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `void` | `setLayoutBottomMargin(java.lang.Integer layoutBottomMargin)` Space outside of all members, on the bottom side.
    `void` | `setLayoutLeftMargin(java.lang.Integer layoutLeftMargin)` Space outside of all members, on the left-hand side.
    `void` | `setLayoutMargin(java.lang.Integer layoutMargin)` Space outside of all members.
    `void` | `setLayoutRightMargin(java.lang.Integer layoutRightMargin)` Space outside of all members, on the right-hand side.
    `void` | `setLayoutTopMargin(java.lang.Integer layoutTopMargin)` Space outside of all members, on the top side.
    `void` | `setLeaveScrollbarGap(java.lang.Boolean leaveScrollbarGap)` Whether to leave a gap for a vertical scrollbar even when one is not actually present.
    `void` | `setLocateMembersBy(LocatorStrategy locateMembersBy)` Strategy to use when locating members from within this Layout's members array.
    `void` | `setLocateMembersType(LocatorTypeStrategy locateMembersType)` `LocatorTypeStrategy` to use when finding members within this layout.
    `com.smartgwt.logicalstructure.core.LogicalStructureObject` | `setLogicalStructure(com.smartgwt.logicalstructure.widgets.layout.LayoutLogicalStructure s)`
    `void` | `setManagePercentBreadth(java.lang.Boolean managePercentBreadth)` If set, a Layout with breadthPolicy:"fill" will specially interpret a percentage breadth on a member as a percentage of available space excluding the `layoutMargin`.
    `void` | `setMemberOverlap(int memberOverlap)` Number of pixels by which each member should overlap the preceding member, used for creating an "stack of cards" appearance for the members of a Layout.
    `void` | `setMembers(Canvas... members)` An array of canvases that will be contained within this layout.
    `void` | `setMembersMargin(int membersMargin)` Space between each member of the layout.
    `void` | `setMinMemberSize(int minMemberSize)` Minimum size, in pixels, below which flexible-sized members should never be shrunk, even if this requires the Layout to overflow.
    `void` | `setOverflow(Overflow overflow)` Normal `Overflow` settings can be used on layouts, for example, an overflow:auto Layout will scroll if members exceed its specified size, whereas an overflow:visible Layout will grow to accommodate members.
    `void` | `setPaddingAsLayoutMargin(java.lang.Boolean paddingAsLayoutMargin)` If this widget has padding specified (as `this.padding` or in the CSS style applied to this layout), should it show up as space outside the members, similar to layoutMargin?
    `void` | `setPlaceHolderDefaults(Canvas placeHolderDefaults)` If `showDragPlaceHolder` is true, this defaults object determines the default appearance of the placeholder displayed when the user drags a widget out of this layout. Default value for this property sets the placeholder `styleName` to `"layoutPlaceHolder"` To modify this object, use `com.smartgwt.client..Class#changeDefaults`
    `void` | `setPlaceHolderProperties(Canvas placeHolderProperties)` If `showDragPlaceHolder` is true, this properties object can be used to customize the appearance of the placeholder displayed when the user drags a widget out of this layout.
    `void` | `setResizeBarClass(java.lang.String resizeBarClass)` Class to use for creating resizeBars.
    `void` | `setResizeBarSize(int resizeBarSize)` Thickness of the resizeBars in pixels
    `void` | `setReverseOrder(java.lang.Boolean reverseOrder)` Reverse the order of stacking for this Layout, so that the last member is shown first.
    `void` | `setShowDragPlaceHolder(java.lang.Boolean showDragPlaceHolder)` If set to true, when a member is dragged out of layout, a visible placeholder canvas will be displayed in place of the dragged widget for the duration of the drag and drop interaction.
    `void` | `setShowDropLines(java.lang.Boolean showDropLines)` Controls whether to show a drop-indicator during a drag and drop operation.
    `void` | `setStackZIndex(java.lang.String stackZIndex)` For use in conjunction with `memberOverlap`, controls the z-stacking order of members.
    `void` | `setVertical(java.lang.Boolean vertical)` Should this layout appear with members stacked vertically or horizontally.
    `void` | `setVisibleMember(Canvas member)` Hide all other members and make the single parameter member visible.
    `void` | `setVPolicy(LayoutPolicy vPolicy)` Sizing policy applied to members on vertical axis
    `void` | `showMember(Canvas member)` Show the specified member, firing the specified callback when the hide is complete.
    `void` | `showMember(Canvas member, Function callback)` Show the specified member, firing the specified callback when the hide is complete.

    - ### Methods inherited from class com.smartgwt.client.widgets.Canvas

      `addChild, addChild, addChild, addChild, addChild, addClickHandler, addDoubleClickHandler, addDragMoveHandler, addDragRepositionMoveHandler, addDragRepositionStartHandler, addDragRepositionStopHandler, addDragResizeMoveHandler, addDragResizeStartHandler, addDragResizeStopHandler, addDragStartHandler, addDragStopHandler, addDropHandler, addDropMoveHandler, addDropOutHandler, addDropOverHandler, addFocusChangedHandler, addHoverHandler, addHoverHiddenHandler, addKeyDownHandler, addKeyPressHandler, addMouseDownHandler, addMouseMoveHandler, addMouseOutHandler, addMouseOverHandler, addMouseStillDownHandler, addMouseUpHandler, addMouseWheelHandler, addMovedHandler, addParentMovedHandler, addPeer, addPeer, addPeer, addPeer, addResizedHandler, addRightMouseDownHandler, addScrolledHandler, addShowContextMenuHandler, addStyleName, addVisibilityChangedHandler, adjustForContent, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateHide, animateHide, animateHide, animateMove, animateMove, animateMove, animateMove, animateRect, animateRect, animateRect, animateRect, animateResize, animateResize, animateResize, animateResize, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateShow, animateShow, animateShow, asSGWTComponent, blur, bringToFront, clear, clickMaskUp, clickMaskUp, contains, contains, containsEvent, containsFocus, containsPoint, containsPoint, deparent, depeer, disable, enable, focus, focusInNextTabElement, focusInPreviousTabElement, getAbsoluteLeft, getAbsoluteTop, getAccessKey, getAnimateAcceleration, getAnimateFadeTime, getAnimateHideAcceleration, getAnimateHideTime, getAnimateMoveAcceleration, getAnimateMoveTime, getAnimateRectAcceleration, getAnimateRectTime, getAnimateResizeAcceleration, getAnimateResizeTime, getAnimateScrollAcceleration, getAnimateScrollTime, getAnimateShowAcceleration, getAnimateShowEffect, getAnimateShowTime, getAnimateTime, getAppImgDir, getAriaRole, getAutoDraw, getAutoShowParent, getBackgroundColor, getBackgroundImage, getBackgroundPosition, getBackgroundRepeat, getBorder, getBottom, getById, getByJSObject, getByLocalId, getCanAcceptDrop, getCanDrag, getCanDragReposition, getCanDragResize, getCanDragScroll, getCanDrop, getCanDropBefore, getCanFocus, getCanHover, getCanSelectText, getCanvasAutoChild, getCanvasItem, getChildren, getChildrenSnapResizeToGrid, getChildrenSnapToGrid, getClassName, getContentElement, getContents, getContextMenu, getCursor, getDataPath, getDefaultHeight, getDefaultWidth, getDestroyed, getDestroying, getDisabled, getDisabledCursor, getDoubleClickDelay, getDragAppearance, getDragIntersectStyle, getDragOpacity, getDragRepositionAppearance, getDragRepositionCursor, getDragResizeAppearance, getDragScrollDelay, getDragStartDistance, getDragTarget, getDragType, getDropTypes, getDynamicContents, getEdgeBackgroundColor, getEdgeCenterBackgroundColor, getEdgeImage, getEdgeMarginSize, getEdgeOffset, getEdgeOpacity, getEdgeShowCenter, getEdgeSize, getEventEdge, getEventEdge, getExtraSpace, getFacetId, getFormItemAutoChild, getFullDataPath, getGroupBorderCSS, getGroupLabelBackgroundColor, getGroupLabelStyleName, getGroupTitle, getHeight, getHeightAsString, getHideUsingDisplayNone, getHoverAlign, getHoverAutoDestroy, getHoverComponent, getHoverDelay, getHoverHeight, getHoverHTML, getHoverMoveWithMouse, getHoverOpacity, getHoverStyle, getHoverVAlign, getHoverWidth, getHoverWrap, getHSnapOrigin, getHSnapOrigin, getHSnapPosition, getHSnapPosition, getHtmlPosition, getImage, getImgURL, getImgURL, getInnerContentHeight, getInnerContentWidth, getInnerHeight, getInnerWidth, getIsGroup, getKeepInParentRect, getLayoutAlign, getLeft, getLeftAsString, getLocateChildrenBy, getLocateChildrenType, getLocatePeersBy, getLocatePeersType, getMargin, getMasterElement, getMatchElement, getMaxHeight, getMaxWidth, getMenuConstructor, getMinHeight, getMinWidth, getMouseStillDownDelay, getMouseStillDownInitialDelay, getNextZIndex, getNoDoubleClicks, getOffsetHeight, getOffsetWidth, getOffsetX, getOffsetY, getOpacity, getOuterElement, getPadding, getPageBottom, getPageLeft, getPageRect, getPageRight, getPageTop, getParentElement, getPeers, getPercentBox, getPercentSource, getPosition, getPrefix, getPrintChildrenAbsolutelyPositioned, getPrintHTML, getPrintHTML, getPrompt, getRect, getRedrawOnResize, getResizeBarTarget, getResizeFrom, getRight, getScrollbarSize, getScrollBottom, getScrollHeight, getScrollLeft, getScrollRight, getScrollTop, getScrollWidth, getShadowDepth, getShadowImage, getShadowOffset, getShadowSoftness, getShouldPrint, getShowCustomScrollbars, getShowDragShadow, getShowEdges, getShowHover, getShowHoverComponents, getShowResizeBar, getShowShadow, getSkinImgDir, getSnapAxis, getSnapEdge, getSnapHDirection, getSnapHGap, getSnapOffsetLeft, getSnapOffsetTop, getSnapOnDrop, getSnapResizeToGrid, getSnapTo, getSnapToGrid, getSnapVDirection, getSnapVGap, getStyleName, getTabIndex, getTestInstance, getTitle, getTooltip, getTop, getTopAsString, getTopElement, getUseBackMask, getUseOpacityFilter, getValuesManager, getViewportHeight, getViewportWidth, getVisibility, getVisibleHeight, getVisibleWidth, getVSnapOrigin, getVSnapOrigin, getVSnapPosition, getVSnapPosition, getWidth, getWidthAsString, getZIndex, handleHover, hide, hideClickMask, hideClickMask, hideContextMenu, imgHTML, imgHTML, imgHTML, intersects, isDirty, isDisabled, isDrawn, isVisible, keyUp, layoutChildren, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, markForDestroy, markForRedraw, markForRedraw, moveAbove, moveBelow, moveBy, moveTo, onAttach, onDetach, parentResized, printComponents, redraw, redraw, removeChild, removeChild, removePeer, removePeer, resizeBy, resizeTo, resizeTo, scrollBy, scrollByPercent, scrollTo, scrollTo, scrollTo, scrollToBottom, scrollToLeft, scrollToPercent, scrollToRight, scrollToTop, sendToBack, setAccessKey, setAllowExternalFilters, setAnimateAcceleration, setAnimateFadeTime, setAnimateHideAcceleration, setAnimateHideTime, setAnimateMoveAcceleration, setAnimateMoveTime, setAnimateRectAcceleration, setAnimateRectTime, setAnimateResizeAcceleration, setAnimateResizeTime, setAnimateScrollAcceleration, setAnimateScrollTime, setAnimateShowAcceleration, setAnimateShowEffect, setAnimateShowTime, setAnimateTime, setAppImgDir, setAriaRole, setAriaState, setAutoChildConstructor, setAutoChildProperties, setAutoChildProperties, setAutoChildVisibility, setAutoDraw, setAutoHeight, setAutoShowParent, setAutoWidth, setBackgroundColor, setBackgroundImage, setBackgroundPosition, setBackgroundRepeat, setBorder, setBottom, setCanAcceptDrop, setCanDrag, setCanDragReposition, setCanDragResize, setCanDragScroll, setCanDrop, setCanDropBefore, setCanFocus, setCanHover, setCanSelectText, setCanvasItem, setChildren, setChildrenSnapResizeToGrid, setChildrenSnapToGrid, setContents, setContextMenu, setCursor, setDataPath, setDefaultHeight, setDefaultProperties, setDefaultWidth, setDisabled, setDisabledCursor, setDoubleClickDelay, setDragAppearance, setDragIntersectStyle, setDragOpacity, setDragRepositionAppearance, setDragRepositionCursor, setDragResizeAppearance, setDragScrollDelay, setDragStartDistance, setDragTarget, setDragType, setDropTypes, setDynamicContents, setEdgeBackgroundColor, setEdgeCenterBackgroundColor, setEdgeImage, setEdgeMarginSize, setEdgeOffset, setEdgeOpacity, setEdgeShowCenter, setEdgeSize, setExtraSpace, setFacetId, setGroupBorderCSS, setGroupLabelBackgroundColor, setGroupLabelStyleName, setGroupTitle, setHeight, setHeight, setHeight100, setHideUsingDisplayNone, setHoverAlign, setHoverAutoDestroy, setHoverDelay, setHoverHeight, setHoverMoveWithMouse, setHoverOpacity, setHoverStyle, setHoverVAlign, setHoverWidth, setHoverWrap, setHtmlPosition, setImage, setImage, setIsGroup, setKeepInParentRect, setKeepInParentRect, setKeepInParentRect, setLayoutAlign, setLayoutAlign, setLeft, setLeft, setLocateChildrenBy, setLocateChildrenType, setLocatePeersBy, setLocatePeersType, setLogicalStructure, setMargin, setMatchElement, setMaxHeight, setMaxWidth, setMenuConstructor, setMinHeight, setMinWidth, setMouseStillDownDelay, setMouseStillDownInitialDelay, setNeverUseFilters, setNoDoubleClicks, setOpacity, setPadding, setPageLeft, setPageTop, setParentElement, setPeers, setPercentBox, setPercentSource, setPosition, setPrefix, setPrintChildrenAbsolutelyPositioned, setPrompt, setRect, setRect, setRedrawOnResize, setResizeBarTarget, setResizeFrom, setResizeFrom, setRight, setScrollbarConstructor, setScrollbarSize, setShadowDepth, setShadowImage, setShadowOffset, setShadowSoftness, setShouldPrint, setShowCustomScrollbars, setShowDragShadow, setShowEdges, setShowHover, setShowHoverComponents, setShowResizeBar, setShowShadow, setSkinImgDir, setSmoothFade, setSnapAxis, setSnapEdge, setSnapHDirection, setSnapHGap, setSnapOffsetLeft, setSnapOffsetTop, setSnapOnDrop, setSnapResizeToGrid, setSnapTo, setSnapToGrid, setSnapVDirection, setSnapVGap, setStyleName, setTabIndex, setTitle, setTooltip, setTop, setTop, setUseBackMask, setUseOpacityFilter, setValuesManager, setVisibility, setVisible, setWidth, setWidth, setWidth100, setZIndex, shouldDragScroll, show, showClickMask, showNextTo, showNextTo, showNextTo, showNextTo, showPrintPreview, showPrintPreview, showPrintPreview, showPrintPreview, showRecursively, updateHover, updateHover, updateShadow, visibleAtPoint, willAcceptDrop`

    - ### Methods inherited from class com.smartgwt.client.widgets.BaseWidget

      `addDrawHandler, destroy, doAddHandler, doInit, doOnRender, draw, equals, error, errorIfNotCreated, getAttribute, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDateArray, getAttributeAsDouble, getAttributeAsElement, getAttributeAsFloat, getAttributeAsFloatArray, getAttributeAsInt, getAttributeAsIntArray, getAttributeAsJavaScriptObject, getAttributeAsMap, getAttributeAsRecord, getAttributeAsString, getAttributeAsStringArray, getConfig, getDOM, getElement, getElement, getHandlerCount, getID, getInnerHTML, getJsObj, getOrCreateJsObj, getRef, getScClassName, hashCode, initNativeObject, internalSetID, internalSetID, isConfigOnly, isCreated, onBind, onDestroy, onDraw, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setConfig, setConfigOnly, setDragTracker, setElement, setHtmlElement, setID, setLogicalStructure, setNullProperty, setPosition, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setScClassName, toString`

    - ### Methods inherited from class com.google.gwt.user.client.ui.Widget

      `addAttachHandler, addBitlessDomHandler, addDomHandler, addHandler, asWidget, asWidgetOrNull, createHandlerManager, delegateEvent, doAttachChildren, doDetachChildren, fireEvent, getLayoutData, getParent, isAttached, isOrWasAttached, onBrowserEvent, onLoad, onUnload, removeFromParent, setLayoutData, sinkEvents`

    - ### Methods inherited from class com.google.gwt.user.client.ui.UIObject

      `addStyleDependentName, ensureDebugId, ensureDebugId, ensureDebugId, getStyleElement, getStyleName, getStylePrimaryName, getStylePrimaryName, isVisible, onEnsureDebugId, removeStyleDependentName, removeStyleName, resolvePotentialElement, setElement, setPixelSize, setSize, setStyleDependentName, setStyleName, setStyleName, setStyleName, setStylePrimaryName, setStylePrimaryName, setVisible, sinkBitlessEvent, unsinkEvents`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

      `fireEvent`

- - ### Constructor Detail

    - #### Layout

          public Layout()

    - #### Layout

          public Layout(com.google.gwt.core.client.JavaScriptObject jsObj)

  - ### Method Detail

    - #### getOrCreateRef

          public static Layout getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### setJavaScriptObject

          public void setJavaScriptObject(com.google.gwt.core.client.JavaScriptObject jsObj)

      Overrides:
        `setJavaScriptObject` in class `Canvas`

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                     Canvas defaults)

      Changes the defaults for Canvas AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - Canvas defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties.
      See Also:
        `AutoChildUsage`

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                     FormItem defaults)

      Changes the defaults for FormItem AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - FormItem defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties.
      See Also:
        `AutoChildUsage`

    - #### create

          protected com.google.gwt.core.client.JavaScriptObject create()

      Overrides:
        `create` in class `Canvas`

    - #### setAnimateMembers

          public void setAnimateMembers(java.lang.Boolean animateMembers)

      If true when members are added / removed, they should be animated as they are shown or hidden in position
      Parameters:
        `animateMembers` - animateMembers Default value is null
      See Also:
        Layout Add & Remove Example

    - #### getAnimateMembers

          public java.lang.Boolean getAnimateMembers()

      If true when members are added / removed, they should be animated as they are shown or hidden in position
      Returns:
        Boolean
      See Also:
        Layout Add & Remove Example

    - #### setAnimateMemberTime

          public void setAnimateMemberTime(java.lang.Integer animateMemberTime)

      If specified this is the duration of show/hide animations when members are being shown or hidden due to being added / removed from this layout.

      Note : This is an advanced setting

      Parameters:
        `animateMemberTime` - animateMemberTime Default value is null

    - #### getAnimateMemberTime

          public java.lang.Integer getAnimateMemberTime()

      If specified this is the duration of show/hide animations when members are being shown or hidden due to being added / removed from this layout.
      Returns:
        Integer

    - #### setCanDropComponents

          public void setCanDropComponents(java.lang.Boolean canDropComponents)
                                    throws java.lang.IllegalStateException

      Layouts provide a default implementation of a drag and drop interaction. If you set `canAcceptDrop`:true and `canDropComponents:true` on a Layout, when a droppable Canvas (`canDrop:true` is dragged over the layout, it will show a dropLine (a simple insertion line) at the drop location.

      When the drop occurs, the dragTarget (obtained using `EventHandler.getDragTarget`) is added as a member of this layout at the location shown by the dropLine (calculated by `Layout.getDropPosition`). This default behavior allows either members or external components that have `canDragReposition` (or `canDrag`) and `canDrop` set to `true` to be added to or reordered within the Layout.

      You can control the thickness of the dropLine via `dropLineThickness` and you can customize the style using css styling in the skin file (look for .layoutDropLine in skin_styles.css for your skin).

      If you want to dynamically create a component to be added to the Layout in response to a drop event you can do so as follows:

            isc.VLayout.create({
              ...various layout properties...
              canDropComponents: true,
              drop : function () {
                // create the new component
                var newMember = isc.Canvas.create();
                // add to the layout at the current drop position
                // (the dropLine will be showing here)
                this.addMember(newMember, this.getDropPosition());
                // hide the dropLine that was automatically shown
                // by builtin Smart GWT methods
                this.hideDropLine();
              }
            });

      If you want to completely suppress the builtin drag and drop logic, but still receive drag and drop events for your own custom implementation, set `canAcceptDrop` to `true` and `canDropComponents` to `false` on your Layout.

      Note : This is an advanced setting

      Parameters:
        `canDropComponents` - canDropComponents Default value is true
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `Dragdrop overview and related methods`

    - #### getCanDropComponents

          public java.lang.Boolean getCanDropComponents()

      Layouts provide a default implementation of a drag and drop interaction. If you set `canAcceptDrop`:true and `canDropComponents:true` on a Layout, when a droppable Canvas (`canDrop:true` is dragged over the layout, it will show a dropLine (a simple insertion line) at the drop location.

      When the drop occurs, the dragTarget (obtained using `EventHandler.getDragTarget`) is added as a member of this layout at the location shown by the dropLine (calculated by `Layout.getDropPosition`). This default behavior allows either members or external components that have `canDragReposition` (or `canDrag`) and `canDrop` set to `true` to be added to or reordered within the Layout.

      You can control the thickness of the dropLine via `dropLineThickness` and you can customize the style using css styling in the skin file (look for .layoutDropLine in skin_styles.css for your skin).

      If you want to dynamically create a component to be added to the Layout in response to a drop event you can do so as follows:

            isc.VLayout.create({
              ...various layout properties...
              canDropComponents: true,
              drop : function () {
                // create the new component
                var newMember = isc.Canvas.create();
                // add to the layout at the current drop position
                // (the dropLine will be showing here)
                this.addMember(newMember, this.getDropPosition());
                // hide the dropLine that was automatically shown
                // by builtin Smart GWT methods
                this.hideDropLine();
              }
            });

      If you want to completely suppress the builtin drag and drop logic, but still receive drag and drop events for your own custom implementation, set `canAcceptDrop` to `true` and `canDropComponents` to `false` on your Layout.
      Returns:
        Boolean
      See Also:
        `Dragdrop overview and related methods`

    - #### setDefaultResizeBars

          public void setDefaultResizeBars(LayoutResizeBarPolicy defaultResizeBars)

      Policy for whether resize bars are shown on members by default. Note that this setting changes the effect of `showResizeBar` for members of this layout.
      Parameters:
        `defaultResizeBars` - defaultResizeBars Default value is "marked"
      See Also:
        `Canvas.setShowResizeBar(java.lang.Boolean)`

    - #### getDefaultResizeBars

          public LayoutResizeBarPolicy getDefaultResizeBars()

      Policy for whether resize bars are shown on members by default. Note that this setting changes the effect of `showResizeBar` for members of this layout.
      Returns:
        LayoutResizeBarPolicy
      See Also:
        `Canvas.getShowResizeBar()`

    - #### getDropLine

          public Canvas getDropLine()
                             throws java.lang.IllegalStateException

      Line showed to mark the drop position when components are being dragged onto this Layout. A simple Canvas typically styled via CSS. The default dropLine.styleName is "layoutDropLine".

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Canvas
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.
      See Also:
        Drag move Example

    - #### setDropLineThickness

          public void setDropLineThickness(int dropLineThickness)
                                    throws java.lang.IllegalStateException

      Thickness, in pixels of the dropLine shown during drag and drop when `canDropComponents` is set to `true`. See the discussion in `Layout` for more info.

      Note : This is an advanced setting

      Parameters:
        `dropLineThickness` - dropLineThickness Default value is 2
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `Layout`, `Dragdrop overview and related methods`, Drag move Example

    - #### getDropLineThickness

          public int getDropLineThickness()

      Thickness, in pixels of the dropLine shown during drag and drop when `canDropComponents` is set to `true`. See the discussion in `Layout` for more info.
      Returns:
        int
      See Also:
        `Layout`, `Dragdrop overview and related methods`, Drag move Example

    - #### setEnforcePolicy

          public void setEnforcePolicy(java.lang.Boolean enforcePolicy)

      Whether the layout policy is continuously enforced as new members are added or removed and as members are resized.

      This setting implies that any member that resizes larger, or any added member, will take space from other members in order to allow the overall layout to stay the same size.

      Note : This is an advanced setting

      Parameters:
        `enforcePolicy` - enforcePolicy Default value is true

    - #### getEnforcePolicy

          public java.lang.Boolean getEnforcePolicy()

      Whether the layout policy is continuously enforced as new members are added or removed and as members are resized.

      This setting implies that any member that resizes larger, or any added member, will take space from other members in order to allow the overall layout to stay the same size.

      Returns:
        Boolean

    - #### setHPolicy

          public void setHPolicy(LayoutPolicy hPolicy)

      Sizing policy applied to members on horizontal axis

      Note : This is an advanced setting

      Parameters:
        `hPolicy` - hPolicy Default value is "fill"

    - #### getHPolicy

          public LayoutPolicy getHPolicy()

      Sizing policy applied to members on horizontal axis
      Returns:
        LayoutPolicy

    - #### setLayoutBottomMargin

          public void setLayoutBottomMargin(java.lang.Integer layoutBottomMargin)

      Space outside of all members, on the bottom side. Defaults to `layoutMargin`.

      Requires a manual call to `setLayoutMargin()` if changed on the fly.

      Parameters:
        `layoutBottomMargin` - layoutBottomMargin Default value is null

    - #### getLayoutBottomMargin

          public java.lang.Integer getLayoutBottomMargin()

      Space outside of all members, on the bottom side. Defaults to `layoutMargin`.

      Requires a manual call to `setLayoutMargin()` if changed on the fly.

      Returns:
        Integer

    - #### setLayoutLeftMargin

          public void setLayoutLeftMargin(java.lang.Integer layoutLeftMargin)

      Space outside of all members, on the left-hand side. Defaults to `layoutMargin`.

      Requires a manual call to `setLayoutMargin()` if changed on the fly.

      Parameters:
        `layoutLeftMargin` - layoutLeftMargin Default value is null

    - #### getLayoutLeftMargin

          public java.lang.Integer getLayoutLeftMargin()

      Space outside of all members, on the left-hand side. Defaults to `layoutMargin`.

      Requires a manual call to `setLayoutMargin()` if changed on the fly.

      Returns:
        Integer

    - #### setLayoutMargin

          public void setLayoutMargin(java.lang.Integer layoutMargin)

      Space outside of all members. This attribute, along with `layoutLeftMargin` and related properties does not have a true setter method.
      It may be assigned directly at runtime. After setting the property, `Layout.setLayoutMargin` may be called with no arguments to reflow the layout.
      If this method is called after the component has been drawn/initialized: Method to force a reflow of the layout after directly assigning a value to any of the layout*Margin properties. Takes no arguments.
      Parameters:
        `layoutMargin` - optional new setting for layout.layoutMargin. Regardless of whether a new layout margin is passed, the layout reflows according to the current settings for layoutStartMargin et al. Default value is null
      See Also:
        `setLayoutLeftMargin(java.lang.Integer)`, `setLayoutRightMargin(java.lang.Integer)`, `setLayoutBottomMargin(java.lang.Integer)`, `setLayoutTopMargin(java.lang.Integer)`, `setPaddingAsLayoutMargin(java.lang.Boolean)`, User Sizing Example

    - #### getLayoutMargin

          public java.lang.Integer getLayoutMargin()

      Space outside of all members. This attribute, along with `layoutLeftMargin` and related properties does not have a true setter method.
      It may be assigned directly at runtime. After setting the property, `Layout.setLayoutMargin` may be called with no arguments to reflow the layout.
      Returns:
        Integer
      See Also:
        `getLayoutLeftMargin()`, `getLayoutRightMargin()`, `getLayoutBottomMargin()`, `getLayoutTopMargin()`, `getPaddingAsLayoutMargin()`, User Sizing Example

    - #### setLayoutRightMargin

          public void setLayoutRightMargin(java.lang.Integer layoutRightMargin)

      Space outside of all members, on the right-hand side. Defaults to `layoutMargin`.

      Requires a manual call to `setLayoutMargin()` if changed on the fly.

      Parameters:
        `layoutRightMargin` - layoutRightMargin Default value is null

    - #### getLayoutRightMargin

          public java.lang.Integer getLayoutRightMargin()

      Space outside of all members, on the right-hand side. Defaults to `layoutMargin`.

      Requires a manual call to `setLayoutMargin()` if changed on the fly.

      Returns:
        Integer

    - #### setLayoutTopMargin

          public void setLayoutTopMargin(java.lang.Integer layoutTopMargin)

      Space outside of all members, on the top side. Defaults to `layoutMargin`.

      Requires a manual call to `setLayoutMargin()` if changed on the fly.

      Parameters:
        `layoutTopMargin` - layoutTopMargin Default value is null

    - #### getLayoutTopMargin

          public java.lang.Integer getLayoutTopMargin()

      Space outside of all members, on the top side. Defaults to `layoutMargin`.

      Requires a manual call to `setLayoutMargin()` if changed on the fly.

      Returns:
        Integer

    - #### setLeaveScrollbarGap

          public void setLeaveScrollbarGap(java.lang.Boolean leaveScrollbarGap)
                                    throws java.lang.IllegalStateException

      Whether to leave a gap for a vertical scrollbar even when one is not actually present.

      This setting avoids the layout resizing all members when the vertical scrollbar is introduced or removed, which can avoid unnecessary screen shifting and improve performance.

      Parameters:
        `leaveScrollbarGap` - leaveScrollbarGap Default value is false
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getLeaveScrollbarGap

          public java.lang.Boolean getLeaveScrollbarGap()

      Whether to leave a gap for a vertical scrollbar even when one is not actually present.

      This setting avoids the layout resizing all members when the vertical scrollbar is introduced or removed, which can avoid unnecessary screen shifting and improve performance.

      Returns:
        Boolean

    - #### setLocateMembersBy

          public void setLocateMembersBy(LocatorStrategy locateMembersBy)

      Strategy to use when locating members from within this Layout's members array.

      Note : This is an advanced setting

      Parameters:
        `locateMembersBy` - locateMembersBy Default value is null

    - #### getLocateMembersBy

          public LocatorStrategy getLocateMembersBy()

      Strategy to use when locating members from within this Layout's members array.
      Returns:
        LocatorStrategy

    - #### setLocateMembersType

          public void setLocateMembersType(LocatorTypeStrategy locateMembersType)

      `LocatorTypeStrategy` to use when finding members within this layout.

      Note : This is an advanced setting

      Parameters:
        `locateMembersType` - locateMembersType Default value is null

    - #### getLocateMembersType

          public LocatorTypeStrategy getLocateMembersType()

      `LocatorTypeStrategy` to use when finding members within this layout.
      Returns:
        LocatorTypeStrategy

    - #### setManagePercentBreadth

          public void setManagePercentBreadth(java.lang.Boolean managePercentBreadth)
                                       throws java.lang.IllegalStateException

      If set, a Layout with breadthPolicy:"fill" will specially interpret a percentage breadth on a member as a percentage of available space excluding the `layoutMargin`. If false, percentages work exactly as for a non-member, with layoutMargins, if any, ignored.
      Parameters:
        `managePercentBreadth` - managePercentBreadth Default value is true
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getManagePercentBreadth

          public java.lang.Boolean getManagePercentBreadth()

      If set, a Layout with breadthPolicy:"fill" will specially interpret a percentage breadth on a member as a percentage of available space excluding the `layoutMargin`. If false, percentages work exactly as for a non-member, with layoutMargins, if any, ignored.
      Returns:
        Boolean

    - #### setMemberOverlap

          public void setMemberOverlap(int memberOverlap)
                                throws java.lang.IllegalStateException

      Number of pixels by which each member should overlap the preceding member, used for creating an "stack of cards" appearance for the members of a Layout.

      `memberOverlap` can be used in conjunction with `stackZIndex` to create a particular visual stacking order.

      Note that overlap of individual members can be accomplished with a negative setting for `extraSpace`.

      Parameters:
        `memberOverlap` - memberOverlap Default value is 0
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `LayoutMember overview and related methods`

    - #### getMemberOverlap

          public int getMemberOverlap()

      Number of pixels by which each member should overlap the preceding member, used for creating an "stack of cards" appearance for the members of a Layout.

      `memberOverlap` can be used in conjunction with `stackZIndex` to create a particular visual stacking order.

      Note that overlap of individual members can be accomplished with a negative setting for `extraSpace`.

      Returns:
        int
      See Also:
        `LayoutMember overview and related methods`

    - #### setMembersMargin

          public void setMembersMargin(int membersMargin)

      Space between each member of the layout.

      Requires a manual call to `reflow()` if changed on the fly.

      Parameters:
        `membersMargin` - membersMargin Default value is 0
      See Also:
        User Sizing Example

    - #### getMembersMargin

          public int getMembersMargin()

      Space between each member of the layout.

      Requires a manual call to `reflow()` if changed on the fly.

      Returns:
        int
      See Also:
        User Sizing Example

    - #### setMinMemberSize

          public void setMinMemberSize(int minMemberSize)
                                throws java.lang.IllegalStateException

      Minimum size, in pixels, below which flexible-sized members should never be shrunk, even if this requires the Layout to overflow.

      Does not apply to members given a fixed size in pixels - such members will never be shrunk below their specified size in general.

      Parameters:
        `minMemberSize` - minMemberSize Default value is 1
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getMinMemberSize

          public int getMinMemberSize()

      Minimum size, in pixels, below which flexible-sized members should never be shrunk, even if this requires the Layout to overflow.

      Does not apply to members given a fixed size in pixels - such members will never be shrunk below their specified size in general.

      Returns:
        int

    - #### setOverflow

          public void setOverflow(Overflow overflow)
                           throws java.lang.IllegalStateException

      Normal `Overflow` settings can be used on layouts, for example, an overflow:auto Layout will scroll if members exceed its specified size, whereas an overflow:visible Layout will grow to accommodate members.
      Overrides:
        `setOverflow` in class `Canvas`
      Parameters:
        `overflow` - overflow Default value is "visible"
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `Sizing overview and related methods`

    - #### getOverflow

          public Overflow getOverflow()

      Normal `Overflow` settings can be used on layouts, for example, an overflow:auto Layout will scroll if members exceed its specified size, whereas an overflow:visible Layout will grow to accommodate members.
      Overrides:
        `getOverflow` in class `Canvas`
      Returns:
        Overflow
      See Also:
        `Sizing overview and related methods`

    - #### setPaddingAsLayoutMargin

          public void setPaddingAsLayoutMargin(java.lang.Boolean paddingAsLayoutMargin)

      If this widget has padding specified (as `this.padding` or in the CSS style applied to this layout), should it show up as space outside the members, similar to layoutMargin?

      If this setting is false, padding will not affect member positioning (as CSS padding normally does not affect absolutely positioned children). Leaving this setting true allows a designer to more effectively control layout purely from CSS.

      Note that `layoutMargin` if specified, takes precedence over this value.

      Note : This is an advanced setting

      Parameters:
        `paddingAsLayoutMargin` - paddingAsLayoutMargin Default value is true

    - #### getPaddingAsLayoutMargin

          public java.lang.Boolean getPaddingAsLayoutMargin()

      If this widget has padding specified (as `this.padding` or in the CSS style applied to this layout), should it show up as space outside the members, similar to layoutMargin?

      If this setting is false, padding will not affect member positioning (as CSS padding normally does not affect absolutely positioned children). Leaving this setting true allows a designer to more effectively control layout purely from CSS.

      Note that `layoutMargin` if specified, takes precedence over this value.

      Returns:
        Boolean

    - #### setResizeBarClass

          public void setResizeBarClass(java.lang.String resizeBarClass)

      Class to use for creating resizeBars.

      A resize bar will be created for any Layout member that specifies ``showResizeBar:true``. Resize bars will be instances of the class specified by this property, and will automatically be sized to the member's breadth and to the thickness given by `resizeBarSize`.
      Classes that are valid by default are `Splitbar` and `ImgSplitbar`.

      To customize the appearance or behavior of resizeBars within some layout a custom resize bar class can be created by subclassing `Splitbar` or `ImgSplitbar` and setting this property on your layout to use your new class.

      Resize bars will automatically be sized to the member's breadth and to the thickness given by `layout.resizeBarSize`. The built-in Splitbar class supports drag resizing of its target member, and clicking on the bar to hide the target member.

      Note : This is an advanced setting

      Parameters:
        `resizeBarClass` - . See `String`. Default value is "Splitbar"
      See Also:
        `Splitbar`, `ImgSplitbar`, `setResizeBarSize(int)`

    - #### getResizeBarClass

          public java.lang.String getResizeBarClass()

      Class to use for creating resizeBars.

      A resize bar will be created for any Layout member that specifies ``showResizeBar:true``. Resize bars will be instances of the class specified by this property, and will automatically be sized to the member's breadth and to the thickness given by `resizeBarSize`.
      Classes that are valid by default are `Splitbar` and `ImgSplitbar`.

      To customize the appearance or behavior of resizeBars within some layout a custom resize bar class can be created by subclassing `Splitbar` or `ImgSplitbar` and setting this property on your layout to use your new class.

      Resize bars will automatically be sized to the member's breadth and to the thickness given by `layout.resizeBarSize`. The built-in Splitbar class supports drag resizing of its target member, and clicking on the bar to hide the target member.

      Returns:
        . See `String`
      See Also:
        `Splitbar`, `ImgSplitbar`, `getResizeBarSize()`

    - #### setResizeBarSize

          public void setResizeBarSize(int resizeBarSize)

      Thickness of the resizeBars in pixels

      Note : This is an advanced setting

      Parameters:
        `resizeBarSize` - resizeBarSize Default value is 7

    - #### getResizeBarSize

          public int getResizeBarSize()

      Thickness of the resizeBars in pixels
      Returns:
        int

    - #### setReverseOrder

          public void setReverseOrder(java.lang.Boolean reverseOrder)

      Reverse the order of stacking for this Layout, so that the last member is shown first.

      Requires a manual call to `reflow()` if changed on the fly.

      In RTL mode, for horizontal Layouts the value of this flag will be flipped during initialization.

      Parameters:
        `reverseOrder` - reverseOrder Default value is false

    - #### getReverseOrder

          public java.lang.Boolean getReverseOrder()

      Reverse the order of stacking for this Layout, so that the last member is shown first.

      Requires a manual call to `reflow()` if changed on the fly.

      In RTL mode, for horizontal Layouts the value of this flag will be flipped during initialization.

      Returns:
        Boolean

    - #### setShowDragPlaceHolder

          public void setShowDragPlaceHolder(java.lang.Boolean showDragPlaceHolder)

      If set to true, when a member is dragged out of layout, a visible placeholder canvas will be displayed in place of the dragged widget for the duration of the drag and drop interaction.
      Parameters:
        `showDragPlaceHolder` - showDragPlaceHolder Default value is null
      See Also:
        `Dragdrop overview and related methods`, Drag move Example

    - #### getShowDragPlaceHolder

          public java.lang.Boolean getShowDragPlaceHolder()

      If set to true, when a member is dragged out of layout, a visible placeholder canvas will be displayed in place of the dragged widget for the duration of the drag and drop interaction.
      Returns:
        Boolean
      See Also:
        `Dragdrop overview and related methods`, Drag move Example

    - #### setShowDropLines

          public void setShowDropLines(java.lang.Boolean showDropLines)

      Controls whether to show a drop-indicator during a drag and drop operation. Set to false if you either don't want to show drop-lines, or plan to create your own.
      Parameters:
        `showDropLines` - showDropLines Default value is null
      See Also:
        `Dragdrop overview and related methods`

    - #### getShowDropLines

          public java.lang.Boolean getShowDropLines()

      Controls whether to show a drop-indicator during a drag and drop operation. Set to false if you either don't want to show drop-lines, or plan to create your own.
      Returns:
        Boolean
      See Also:
        `Dragdrop overview and related methods`

    - #### setStackZIndex

          public void setStackZIndex(java.lang.String stackZIndex)
                              throws java.lang.IllegalStateException

      For use in conjunction with `memberOverlap`, controls the z-stacking order of members.

      If "lastOnTop", members stack from the first member at bottom to the last member at top. If "firstOnTop", members stack from the last member at bottom to the first member at top.

      Parameters:
        `stackZIndex` - . See `String`. Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getStackZIndex

          public java.lang.String getStackZIndex()

      For use in conjunction with `memberOverlap`, controls the z-stacking order of members.

      If "lastOnTop", members stack from the first member at bottom to the last member at top. If "firstOnTop", members stack from the last member at bottom to the first member at top.

      Returns:
        . See `String`

    - #### setVertical

          public void setVertical(java.lang.Boolean vertical)

      Should this layout appear with members stacked vertically or horizontally. Defaults to `false` if unspecified.
      Parameters:
        `vertical` - vertical Default value is null

    - #### getVertical

          public java.lang.Boolean getVertical()

      Should this layout appear with members stacked vertically or horizontally. Defaults to `false` if unspecified.
      Returns:
        Boolean

    - #### setVPolicy

          public void setVPolicy(LayoutPolicy vPolicy)

      Sizing policy applied to members on vertical axis

      Note : This is an advanced setting

      Parameters:
        `vPolicy` - vPolicy Default value is "fill"

    - #### getVPolicy

          public LayoutPolicy getVPolicy()

      Sizing policy applied to members on vertical axis
      Returns:
        LayoutPolicy

    - #### getDropPosition

          public int getDropPosition()

      Get the position a new member would be dropped. This drop position switches in the middle of each member, and both edges (before beginning, after end) are legal drop positions

      Use this method to obtain the drop position for e.g. a custom drop handler.

      Returns:
        the position a new member would be dropped

    - #### getMemberDefaultBreadth

          public void getMemberDefaultBreadth(Canvas member,
                                     int defaultBreadth)

      Return the breadth for a member of this layout which either didn't specify a breadth or specified a percent breadth with `managePercentBreadth`:true.

      Called only for Layouts which have a `layout policy` for the breadth axis of "fill", since Layouts with a breadth policy of "none" leave all member breadths alone.

      Parameters:
        `member` - Component to be sized
        `defaultBreadth` - Value of the currently calculated member breadth. This may be returned verbatim or manipulated in this method.
      See Also:
        `LayoutMember overview and related methods`

    - #### getMemberOffset

          public void getMemberOffset(Canvas member,
                             int defaultOffset,
                             java.lang.String alignment)

      Override point for changing the offset on the breadth axis for members, that is, the offset relative to the left edge for a vertical layout, or the offset relative to the top edge for a horizontal layout.

      The method is passed the default offset that would be used for the member if getMemberOffset() were not implemented. This default offset already takes into account `layoutMargin`, as well as the `alignment on the breadth axis`, which is also passed to getMemberOffset().

      This method is an override point only; it does not exist by default and cannot be called.

      Parameters:
        `member` - Component to be positioned
        `defaultOffset` - Value of the currently calculated member offset. If this value is returned unchanged the layout will have its default behavior
        `alignment` - alignment of the enclosing layout, on the breadth axis
      See Also:
        `LayoutMember overview and related methods`

    - #### hasMember

          public java.lang.Boolean hasMember(Canvas canvas)

      Returns true if the layout includes the specified canvas.
      Parameters:
        `canvas` - the canvas to check for
      Returns:
        true if the layout includes the specified canvas

    - #### hideDropLine

          public void hideDropLine()

      Calling this method hides the dropLine shown during a drag and drop interaction with a Layout that has `canDropComponents` set to true. This method is only useful for custom implementations of `Layout.drop` as the default implementation calls this method automatically.

    - #### membersChanged

          public void membersChanged()

      Fires once at initialization if the layout has any initial members, and then fires whenever members are added, removed or reordered.

    - #### reflow

          public void reflow()

      Layout members according to current settings.

      Members will reflow automatically when the layout is resized, members resize, the list of members changes or members change visibility. It is only necessary to manually call `reflow()` after changing settings on the layout, for example, `layout.reverseOrder`.

    - #### reflow

          public void reflow(java.lang.String reason)

      Layout members according to current settings.

      Members will reflow automatically when the layout is resized, members resize, the list of members changes or members change visibility. It is only necessary to manually call `reflow()` after changing settings on the layout, for example, `layout.reverseOrder`.

      Parameters:
        `reason` - reason reflow() had to be called (appear in logs if enabled)

    - #### reflowNow

          public void reflowNow()

      Layout members according to current settings, immediately.
      Generally, when changes occur that require a layout to reflow (such as members being shown or hidden), the Layout will reflow only after a delay, so that multiple changes cause only one reflow. To remove this delay for cases where it is not helpful, reflowNow() can be called.

    - #### removeMember

          public void removeMember(Canvas member)

      Removes the specified member from the layout. If it has a resize bar, the bar will be destroyed.
      Parameters:
        `member` - the canvas to be removed from the layout

    - #### removeMembers

          public void removeMembers(Canvas... members)

      Removes the specified members from the layout. If any of the removed members have resize bars, the bars will be destroyed.
      Parameters:
        `members` - array of members to be removed, or single member

    - #### reorderMember

          public void reorderMember(int memberNum,
                           int newPosition)

      Shift a member of the layout to a new position
      Parameters:
        `memberNum` - current position of the member to move to a new position
        `newPosition` - new position to move the member to

    - #### reorderMembers

          public void reorderMembers(int start,
                            int end,
                            int newPosition)

      Move a range of members to a new position
      Parameters:
        `start` - beginning of range of members to move
        `end` - end of range of members to move, non-inclusive
        `newPosition` - new position to move the members to

    - #### setVisibleMember

          public void setVisibleMember(Canvas member)

      Hide all other members and make the single parameter member visible.
      Parameters:
        `member` - member to show

    - #### setDefaultProperties

          public static void setDefaultProperties(Layout layoutProperties)

      Class level method to set the default properties of this class. If set, then all subsequent instances of this class will automatically have the default properties that were set when this method was called. This is a powerful feature that eliminates the need for users to create a separate hierarchy of subclasses that only alter the default properties of this class. Can also be used for skinning / styling purposes.

      Note: This method is intended for setting default attributes only and will effect all instances of the underlying class (including those automatically generated in JavaScript). This method should not be used to apply standard EventHandlers or override methods for a class - use a custom subclass instead.

      Parameters:
        `layoutProperties` - properties that should be used as new defaults when instances of this class are created

    - #### onInit

          protected void onInit()

      Overrides:
        `onInit` in class `Canvas`

    - #### onInit_Layout

          protected void onInit_Layout()

    - #### getDropComponent

          protected Canvas getDropComponent(Canvas dragTarget,
                                int dropPosition)

    - #### addMembers

          public void addMembers(Canvas... newMembers)

      Add one or more canvases to the layout. NOTE: depending on the layout policy, adding a new member may cause existing members to resize.
      Parameters:
        `newMembers` - canvases to be added

    - #### addMembers

          public void addMembers(Canvas[] newMembers,
                        int position)

      Add one or more canvases to the layout at specific positions. NOTE: depending on the layout policy, adding a new member may cause existing members to resize.
      Parameters:
        `newMembers` - array of canvases to be added
        `position` - position to add newMembers position

    - #### setMembers

          public void setMembers(Canvas... members)

      An array of canvases that will be contained within this layout. You can set the following properties on these canvases (in addition to the standard component properties):
      - layoutAlign--specifies the member's alignment along the breadth axis; valid values are "top", "center" and "bottom" for a horizontal layout and "left", "center" and "right" for a vertical layout (see `defaultLayoutAlign` for default implementation.)
      - showResizeBar--set to true to show a resize bar (default is false)
      Height and width settings found on members are interpreted by the Layout according to the `vPolicy`.
      Parameters:
        `members` - members Default value is null

    - #### addMember

          public void addMember(com.google.gwt.user.client.ui.Widget widget)

      Add a canvas to the layout, optionally at a specific position.
      Parameters:
        `widget` - the canvas object to be added to the layout

    - #### addMember

          public void addMember(Canvas component)

      Add a canvas to the layout, optionally at a specific position.
      Parameters:
        `component` - the canvas object to be added to the layout

    - #### addMember

          public void addMember(com.google.gwt.user.client.ui.Widget widget,
                       int position)

    - #### addMember

          public void addMember(Canvas component,
                       int position)

      Add a canvas to the layout, optionally at a specific position.
      Parameters:
        `component` - the canvas object to be added to the layout
        `position` - the position in the layout to place newMember (starts with 0); if omitted, it will be added at the last position

    - #### addMemberPreCreate

          protected void addMemberPreCreate(java.lang.Object componentJS)

    - #### addMemberPostCreate

          protected void addMemberPostCreate(java.lang.Object componentJS)

    - #### addMemberPreCreate

          protected void addMemberPreCreate(java.lang.Object componentJS,
                                int position)

    - #### addMemberPostCreate

          protected void addMemberPostCreate(java.lang.Object componentJS,
                                 int position)

    - #### setPlaceHolderProperties

          public void setPlaceHolderProperties(Canvas placeHolderProperties)
                                        throws java.lang.IllegalStateException

      If `showDragPlaceHolder` is true, this properties object can be used to customize the appearance of the placeholder displayed when the user drags a widget out of this layout.
      Parameters:
        `placeHolderProperties` - placeHolderProperties Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### setPlaceHolderDefaults

          public void setPlaceHolderDefaults(Canvas placeHolderDefaults)
                                      throws java.lang.IllegalStateException

      If `showDragPlaceHolder` is true, this defaults object determines the default appearance of the placeholder displayed when the user drags a widget out of this layout.
      Default value for this property sets the placeholder `styleName` to `"layoutPlaceHolder"`
      To modify this object, use `com.smartgwt.client..Class#changeDefaults`
      Parameters:
        `placeHolderDefaults` - placeHolderDefaults Default value is {...}
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### setDefaultLayoutAlign

          public void setDefaultLayoutAlign(Alignment alignment)
                                     throws java.lang.IllegalStateException

      Specifies the default alignment for layout members on the breadth axis. Can be overridden on a per-member basis by setting `layoutAlign`.
      If unset, default member layout alignment will be "top" for a horizontal layout, and left for a vertical layout.
      Parameters:
        `alignment` - defaultLayoutAlign Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### setDefaultLayoutAlign

          public void setDefaultLayoutAlign(VerticalAlignment alignment)
                                     throws java.lang.IllegalStateException

      Specifies the default alignment for layout members on the breadth axis. Can be overridden on a per-member basis by setting `layoutAlign`.
      If unset, default member layout alignment will be "top" for a horizontal layout, and left for a vertical layout.
      Parameters:
        `alignment` - defaultLayoutAlign Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### setDropLineProperties

          public void setDropLineProperties(Canvas dropLineProperties)
                                     throws java.lang.IllegalStateException

      Throws:
        `java.lang.IllegalStateException`

    - #### setAlign

          public void setAlign(Alignment alignment)

      Alignment of all members in this Layout on the length axis. Defaults to "top" for vertical Layouts, and "left" for horizontal Layouts.
      Overrides:
        `setAlign` in class `Canvas`
      Parameters:
        `alignment` - alignment Default value is null

    - #### setAlign

          public void setAlign(VerticalAlignment alignment)

      Alignment of all members in this Layout on the length axis. Defaults to "top" for vertical Layouts, and "left" for horizontal Layouts.
      Parameters:
        `alignment` - alignment Default value is null

    - #### getMembers

          public Canvas[] getMembers()

      Return the members in the Layout.
      Returns:
        the members

    - #### showMember

          public void showMember(Canvas member)

      Show the specified member, firing the specified callback when the hide is complete.

      Members can always be directly shown via `member.show()`, but if `animateMembers` is enabled, animation will only occur if showMember() is called to show the member.

      Parameters:
        `member` - Member to show

    - #### showMember

          public void showMember(Canvas member,
                        Function callback)

      Show the specified member, firing the specified callback when the hide is complete.

      Members can always be directly shown via `member.show()`, but if `animateMembers` is enabled, animation will only occur if showMember() is called to show the member.

      Parameters:
        `member` - Member to show
        `callback` - action to fire when the member has been shown

    - #### hideMember

          public void hideMember(Canvas member)

      Hide the specified member, firing the specified callback when the hide is complete.

      Members can always be directly hidden via `member.hide()`, but if `animateMembers` is enabled, animation will only occur if hideMember() is called to hide the member.

      Parameters:
        `member` - Member to hide

    - #### hideMember

          public void hideMember(Canvas member,
                        Function callback)

      Hide the specified member, firing the specified callback when the hide is complete.

      Members can always be directly hidden via `member.hide()`, but if `animateMembers` is enabled, animation will only occur if hideMember() is called to hide the member.

      Parameters:
        `member` - Member to hide
        `callback` - callback to fire when the member is hidden.

    - #### getMember

          public Canvas getMember(int index)

      Given a numerical index or a member ID, return a pointer to the appropriate member.

      If passed a member Canvas, just returns it.

      Parameters:
        `index` - index for the member
      Returns:
        member widget

    - #### getMember

          public Canvas getMember(java.lang.String memberID)

      Given a numerical index or a member ID, return a pointer to the appropriate member.

      If passed a member Canvas, just returns it.

      Parameters:
        `memberID` - identifier for the required member
      Returns:
        member widget

    - #### getMemberNumber

          public int getMemberNumber(Canvas member)

      Given a member Canvas or member ID, return the index of that member within this layout's members array

      If passed a number, just returns it.

      Parameters:
        `member` - the member
      Returns:
        index of the member canvas (or -1 if not found)

    - #### getMemberNumber

          public int getMemberNumber(java.lang.String memberID)

      Given a member Canvas or member ID, return the index of that member within this layout's members array

      If passed a number, just returns it.

      Parameters:
        `memberID` - identifier for the required member
      Returns:
        index of the member canvas (or -1 if not found)

    - #### setLogicalStructure

          public com.smartgwt.logicalstructure.core.LogicalStructureObject setLogicalStructure(com.smartgwt.logicalstructure.widgets.layout.LayoutLogicalStructure s)

    - #### getLogicalStructure

          public com.smartgwt.logicalstructure.core.LogicalStructureObject getLogicalStructure()

      Specified by:
        `getLogicalStructure` in interface `LogicalStructure`
      Overrides:
        `getLogicalStructure` in class `Canvas`